<?php
/**
 * Created by PhpStorm.
 * User: aisrael
 * Date: 2019-01-29
 * Time: 17:08
 */

namespace Drupal\xtc\XtendedContent\API;


use Drupal\xtc\PluginManager\XtcProfile\XtcProfileDefault;

class XtcLoaderProfile extends XtcLoaderBase {

  public static function get($name, $options = []): XtcProfileDefault {
    return parent::get($name);
  }

  /**
   * @param $name
   * @param array $options
   *
   * @return string|null
   */
  public static function process($name, $options = []) {
    $handler = self::loadHandler($name, $options);
    if(!empty($handler)){
      return $handler->process();
    }
    return NULL;
  }

  /**
   * @param $name
   * @param array $options
   *
   * @return string|null
   */
  public static function delete($name, $options = []) {
    $handler = self::loadHandler($name, $options);
    if(!empty($handler)){
      return $handler->process();
    }
    return NULL;
  }

  /**
   * @param $name
   * @param array $options
   *
   * @return string|null
   */
  public static function content($name, $options = []) {
    $handler = self::loadHandler($name, $options);
    if(!empty($handler)){
      return $handler->processContent();
    }
    return NULL;
  }

  /**
   * @param $name
   * @param array $options
   *
   * @return mixed|null
   */
  public static function values($name, $options = []) {
    $handler = self::loadHandler($name, $options);
    if(!empty($handler)){
      return $handler->processValues();
    }
    return NULL;
  }

  /**
   * @param $name
   * @param array $options
   *
   * @return mixed|null
   */
  public static function filters($name, $options = []) {
    $handler = self::loadHandler($name, $options);
    if(!empty($handler)){
      return $handler->processFilters();
    }
    return NULL;
  }

  protected static function getService(): string {
    return 'plugin.manager.xtc_profile';
  }

  protected static function loadHandler($name, $options = []) {
    $profile = self::load($name);
    if (!empty($profile)) {
      if (!empty($profile['args'])) {
        $options = array_merge($options, $profile['args']);
      }
      $handler = XtcLoaderHandler::get($profile['type'] . '_' . $profile['verb']);
      return $handler->setProfile($profile)
        ->setOptions($options);
    }
    return NULL;
  }

}
